<?php

/******************** MOLE -- Copyright 2008 *************************
 *
 * By
 * 		Erik Clairiot <ipingu *AT* clairiot _DOT_ com>
 * 		Remi Melisson <tospecify>
 *
 * This file is working implementation of an XMLRPC server, written in
 * PHP, designed to purpose to users all services they need to
 * use well their Mole client. Since the communication protocol is
 * defined by the specification we wrote, using XMLRPC, client can use
 * any server implementation.
 * This server use the PHPXMLRPC library, 2.2, available at
 * 		http://phpxmlrpc.sourceforge.net
 *
 * Mole is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * mOLE is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Mole; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *********************************************************************/

/* Config file */
require_once("../conf/Conf.inc.php");

/* XML RPC libraries to load */
require_once("../libs/xmlrpc/xmlrpc.inc.php");
require_once("../libs/xmlrpc/xmlrpcs.inc.php");

/* Services to publish */
include("../services/Connection.php");
include("../services/JoinChannel.php");
include("../services/ListChannels.php");
include("../services/ListChannelUsers.php");
include("../services/HelloWorld.php");

/* Array containing all services that this server purposes */
$all_services = array(
    'mole.hello' => array(
	'function' => 'HelloWorld::execute',
	'signature' => array(array($xmlrpcString, $xmlrpcString)),
	'docstring' => 'Hello world!'
    ),
    'mole.connection' => array(
	'function' => 'SQLConnection::execute',
	'signature' => array(array($xmlrpcString, $xmlrpcString,
	$xmlrpcString, $xmlrpcInt)),
	'docstring' => 'Log a client on the server'
    ),
    'mole.joinChannel' => array(
	'function' => 'SQLJoinChannel::execute',
	'signature' => array(array($xmlrpcBoolean, $xmlrpcString, $xmlrpcString)),
	'docstring' => 'Join a channel'
    ),
    'mole.listChannels' => array(
	'function' => 'SQLListChannels::execute',
	'signature' => array(array($xmlrpcArray, $xmlrpcString)),
	'docstring' => 'List all channels'
    ),
    'mole.listChannelUsers' => array(
	'function' => 'SQLListChannelUsers::execute',
	'signature' => array(array($xmlrpcArray, $xmlrpcString, $xmlrpcString)),
	'docstring' => 'List all users on a channel'
    ));

/* 0 to force the server to not begin services request */
$server = new xmlrpc_server($all_services, 0);

$server->compress_response = true;

$server->service();

?>
