<?php

require_once('Service.php');
require_once('../libs/database/MySQLQuery.php');
require_once('../helper/ServicesQueryHelper.php');

abstract class ListChannelUsers implements Service {

    protected static $errcode = array('unknown_chan' => 101);

    protected static $errtext = array('unknown_chan' => "Unknown channel.");

};

class SQLListChannelUsers extends ListChannelUsers {

    public function execute($args){
	$molid = $args->getParam(0)->scalarVal();
	$name = $args->getParam(1)->scalarVal();
	/* TODO : Check policy */
	/* This service requires that client was previously auth on
	 * the server. Policy class do it for us. */
	if (!Policy::checkAuth($molid))
	    return Policy::getXmlrpcresp();
	

	if (SQLServicesQueryHelper::channelExists($name)){
	    $users = SQLServicesQueryHelper::getChannelUsers($name);
	    for ($i = 0; $i < count($users); $i++){
		$users[$i] = new xmlrpcval($users[$i]->name, 'string');
	    }

	    return new xmlrpcresp(new xmlrpcval($users, 'array'));
	} else {
	    $status = 'unknown_chan';
	    return new xmlrpcresp(0, self::$errcode[$status], self::$errtext[$status]);
	}

    }
}

?>
